private void ZoomableChart_InterpolateValues(object sender, InterpolateValuesEventArgs e)
{
    // hold the null column numbers and the values of the data
    int[] ni = e.NullValueIndices;
    Array vals = e.Values;

    if (ni.Length >= vals.Length)
        return;

    // lastgood will be the last position in which a non-null was found
    int lastgood = -1;
    double lastgoodvalue = 0;

    // looping through all the null points in my data
    for(int z=0;z<ni.Length;z++)
    {
        int n = ni[z];
        if (n > 0 && n < vals.Length)
        {
            // test for a non-null value to see and mark it as the last good position
            // if it is non-null
            if (vals.GetValue((int)n - 1) != null)
            {
                lastgood = n - 1;
                lastgoodvalue = (double)vals.GetValue((int)n - 1);
            }

            // if i'm at the end of my datavalues and i have a null value to deal with,
            // just set it to the last known good value
            bool nonnullcoming = false;
            for (int x = n+1; x < vals.Length; x++)
            {
                if (vals.GetValue((int)x) != null)
                {
                    nonnullcoming = true;
                    break;
                }
            }

            if (!nonnullcoming)
            {
                for (int x = n; x < vals.Length;x++)
                {
                    vals.SetValue(lastgoodvalue, x);
                }
                break;
            }
            else
            {
                if (n + 1 == vals.Length)
                {
                    double lgval = (double)vals.GetValue(lastgood);
                    vals.SetValue(lgval, (int)n);
                }
                else if (vals.GetValue((int)n + 1) != null && lastgood != n && lastgood > -1)
                {
                    // grab the last non-null and the next non-null value
                    double lgval = (double)vals.GetValue(lastgood);
                    double ngval = (double)vals.GetValue(n + 1);

                    // grab the information for the interpolation
                    int divideby = n + 1 - lastgood;
                    double incremental = (ngval - lgval) / divideby;

                    // for all the consecutive nulls between the lastgood position
                    // and the next non-null position, insert a linear interpolation value
                    for (int spcs = lastgood + 1; spcs < n + 1; spcs++)
                    {
                        double tmp = lgval + (incremental * (spcs - lastgood));
                        vals.SetValue(tmp, (int)spcs);
                    }
                }
                else if (vals.GetValue((int)n + 1) != null && lastgood != n && lastgood < 0)
                {
                    double ngval = (double)vals.GetValue(n + 1);

                    // for all the consecutive nulls between the lastgood position
                    // and the next non-null position, insert a linear interpolation value
                    for (int spcs = 0; spcs < n + 1; spcs++)
                    {
                        double tmp = ngval;
                        vals.SetValue(tmp, (int)spcs);
                    }

                }
            }
        }
    }
}